<template>
    <!-- <x-search-bar class="mb-8-2">
        <template #default="{ gutter, colSpan }">
            <a-form :model="searchFormData" layout="inline">
                <a-row :gutter="gutter">
                    <a-col v-bind="colSpan">
                        <a-form-item label="岗位名称" name="name">
                            <a-input placeholder="请输入岗位名称" v-model:value="searchFormData.name"></a-input>
                        </a-form-item>
                    </a-col>

                    <a-col v-bind="colSpan">
                        <a-form-item label="状态" name="status">
                            <a-select v-model:value="searchFormData.status" allowClear>
                                <a-select-option value="">全部</a-select-option>
                                <a-select-option value="enabled">启用</a-select-option>
                                <a-select-option value="disabled">停用</a-select-option>
                            </a-select>
                        </a-form-item>
                    </a-col>
                    <a-col class="align-right" v-bind="colSpan">
                        <a-space>
                            <a-button @click="handleResetSearch">{{ $t('button.reset') }}</a-button>
                            <a-button ghost type="primary" @click="handleSearch">
                                {{ $t('button.search') }}
                            </a-button>
                        </a-space>
                    </a-col>
                </a-row>
            </a-form>
        </template>
</x-search-bar> -->
    <a-row :gutter="8" :wrap="false">
        <a-col flex="auto">
            <a-card type="flex">
                <x-action-bar class="mb-8-2">
                    <a-button type="primary" @click="$refs.editDialogRef.handleCreate()">
                        <template #icon>
                            <plus-outlined></plus-outlined>
                        </template>
                        新增房刊
                    </a-button>
                </x-action-bar>
                <a-table :columns="columns" :data-source="listData" bordered="true" :loading="loading"
                    :pagination="paginationState" :scroll="{ x: 1000 }" @change="onTableChange">
                    <template #bodyCell="{ column, record }">
                        <template v-if="column.dataIndex === 'areaId'">
                            <span>{{ areaEnum.getName(record.areaId) }}</span>
                        </template>
                        <template v-if="column.dataIndex === 'cover'">
                            <a-image :width="60" :src="config('http.apiBasic') + record.cover || $imageErr.imgErr" />
                        </template>
                        <template v-if="column.dataIndex === 'pushAt'">
                            <span>{{ dayjs(record.pushAt).format('YYYY-MM-DD') }}</span>
                        </template>
                         <template v-if="column.dataIndex === 'content'">
                             <span style="cursor: pointer;color:#1677ff;"
                                @click="content = decryptString(record.content) || ''; modalType = 2; qropen = true" type="link">点击查看</span>
                        </template>
                        <template v-if="'status' === column.dataIndex">
                            <a-tag v-if="record.status === 'enabled'" :color="'green'">启用</a-tag>
                            <a-tag v-if="record.status === 'disabled'" :color="'red'">停用</a-tag>
                        </template>
                        <template v-if="'action' === column.key">
                            <x-action-button @click="$refs.editDialogRef.handleEdit(record)">
                                <a-tooltip>
                                    <template #title> {{ $t('pages.system.user.edit') }}</template>
                                    <edit-outlined /> </a-tooltip></x-action-button>
                            <x-action-button @click="handleDelete(record)">
                                <a-tooltip>
                                    <template #title>{{ $t('pages.system.delete') }}</template>
                                    <delete-outlined style="color: #ff4d4f" /> </a-tooltip></x-action-button>
                        </template>
                    </template>
                </a-table>
            </a-card>
        </a-col>
    </a-row>

    <a-modal v-model:open="qropen" :title="modalType==1?'生成二维码':'查看内容'" @ok="qropen = false" :footer="null">
        <a-card v-if="modalType==1" class="mb-8-2"
            style="display: flex;align-items: center;flex-direction: column;justify-content: center;">
            <x-qrCode :value="qrValue" :icon="qrlogo" :iconBackgroundColor="'#ffffff'" :size="180"></x-qrCode>
        </a-card>
        <a-card v-else >
            <div style="height: 450px;overflow-y: scroll;">
                <div v-html="content" ></div>
            </div>
        </a-card>
    </a-modal>
    <edit-dialog ref="editDialogRef" @ok="onOk"></edit-dialog>
</template>

<script setup>
import { message, Modal } from 'ant-design-vue'
import { ref } from 'vue'
import apis from '@/apis'
import { formatUtcDateTime } from '@/utils/util'
import { config } from '@/config'
import dayjs from 'dayjs'
import { usePagination } from '@/hooks'
import EditDialog from './components/EditDialog.vue'
import { PlusOutlined, EditOutlined, DeleteOutlined, QrcodeOutlined } from '@ant-design/icons-vue'
import { useI18n } from 'vue-i18n'
import qrlogo from '@/assets/qrlogo.png'
import { customersEnum, areaEnum } from "@/enums/useEnum"
import { decryptString } from "@/utils/util"
const content = ref('')
const modalType=ref(1)
const qrValue = ref('')
const qropen = ref(false)
defineOptions({
    name: 'hoseBookList',
})
const { t } = useI18n() // 解构出t方法
const columns = [
    { title: '所属区域', dataIndex: 'areaId', width: 90, align: 'center' },
    { title: '封面', dataIndex: 'cover', width: 120, align: 'center' },
    { title: '房刊标题', dataIndex: 'title', width: 120, align: 'center', ellipsis: true },
    { title: '楼盘名称', dataIndex: 'name', key: 'title', ellipsis: true },
    { title: '发布时间', dataIndex: 'pushAt', key: 'pushAt' },
    { title: '内容', dataIndex: 'content', key: 'title', ellipsis: true },
    { title: '状态', dataIndex: 'status', key: 'introduce', width: 100, align: 'center' },
    { title: t('button.action'), key: 'action', fixed: 'right', width: 150, align: 'center' },
]

const { listData, loading, showLoading, hideLoading, paginationState, resetPagination, searchFormData } =
    usePagination()

const editDialogRef = ref()
getPageList()
/**
 * 获取表格数据
 * @returns {Promise<void>}
 */
async function getPageList() {
    try {
        showLoading()
        const { pageSize, current } = paginationState
        const { success, data, total } = await apis.houseArticles
            .getProjectList({
                pageSize,
                current: current,
                ...searchFormData.value,
            })
            .catch(() => {
                throw new Error()
            })
        hideLoading()
        if (config('http.code.success') === success) {
            listData.value = data
            paginationState.total = total
        }
    } catch (error) {
        hideLoading()
    }
}

/**
 * 删除
 */
function handleDelete({ id }) {
    Modal.confirm({
        title: t('pages.system.user.delTip'),
        content: t('button.confirm'),
        okText: t('button.confirm'),
        onOk: () => {
            return new Promise((resolve, reject) => {
                ; (async () => {
                    try {
                        const { success } = await apis.houseArticles.delItem(id).catch(() => {
                            throw new Error()
                        })
                        if (config('http.code.success') === success) {
                            resolve()
                            message.success(t('component.message.success.delete'))
                            await getPageList()
                        }
                    } catch (error) {
                        reject()
                    }
                })()
            })
        },
    })
}

/**
 * 分页
 */
function onTableChange({ current, pageSize }) {
    paginationState.current = current
    paginationState.pageSize = pageSize
    getPageList()
}

/**
 * 搜索
 */
function handleSearch() {
    resetPagination()
    getPageList()
}
/**
 * 重置
 */
function handleResetSearch() {
    searchFormData.value = {}
    resetPagination()
    getPageList()
}
const createQrcode = (params) => {
    const { name, areaId, id } = params
    const item = {
        title: name,
        typer: 'activity',
        pathUrl: '/pages/sceneDetail/index.vue',
        areaId,
        relationId: id,
        kvalue1: '',
        kvalue2: '',
        kvalue3: '',
        kvalue4: '',
        kvalue5: '',
    }
    qrValue.value = JSON.stringify(item)
    console.log(qrValue.value)
    qropen.value = true
}
/**
 * 编辑完成
 */
async function onOk() {
    await getPageList()
}
</script>

<style lang="less" scoped></style>
